<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<%@taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <title>WebSockets</title>

    <link type="text/css" href="<c:url value="/resources/css/screen.css"/>" rel="stylesheet" />
    <link type="text/css" href="<c:url value="/resources/css/styles.css"/>" rel="stylesheet" />
    <link type="text/css" href="<c:url value="/resources/css/smoothness/jquery-ui-1.8.18.custom.css"/>" rel="stylesheet" />
    <script type="text/javascript" src="<c:url value="/resources/js/jquery-1.7.1.min.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery-ui-1.8.18.custom.min.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery.cookie.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/backbone-min.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery.colorpicker.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery.mousewheel.js" />"></script>

    <script type="text/javascript">
        var volumes = $.parseJSON('{"room1":0,"room2":0,"room3":0,"room4":0}');
        var devices = [
            {"red":72,"green":69,"blue":255,"startAddress":1,"type":"Par56Spot","deviceId":0,"deviceName":"Par56 Lampe 1","picture":null},
            {"red":111,"green":222,"blue":23,"startAddress":6,"type":"Par56Spot","deviceId":1,"deviceName":"Par56 Lampe 2","picture":null},
            {"red":0,"green":0,"blue":0,"startAddress":11,"type":"Par56Spot","deviceId":2,"deviceName":"Par56 Lampe 3","picture":null},
            {"red":0,"green":0,"blue":0,"startAddress":16,"type":"Par56Spot","deviceId":3,"deviceName":"Par56 Lampe 4","picture":null},
            {"mode":0,"speed":0,"intensity":0,"startAddress":21,"type":"Strobe1500","deviceId":4,"deviceName":"Stroboskop 1","picture":null},
            {"red":0,"green":0,"blue":0,"startAddress":508,"type":"Par56Spot","deviceId":5,"deviceName":"Par56 Lampe 5","picture":null}
        ];
        $(document).ready(
            function() {


                function sendData(data) {
                    $.ajax({
                        type: 'POST',
                        url: "/control/devices",
                        contentType: "application/json",
                        dataType: "json",
                        data: JSON.stringify(data)
                    });
                    console.log(data);
                    console.log(JSON.stringify(data));
                }

                var senden = function sendOutAllDevices() {
                    var changedDevs = new Array();
                    for(var i=0;i<devices.length;i++) {
                        if(devices[i].type=="Par56Spot" && devices[i].dirty) {
                            delete devices[i].dirty;
                            var dev = {"deviceId": i, "options":{"red":devices[i].red, "green":devices[i].green, "blue":devices[i].blue}};
                            changedDevs.push(dev);
                        }
                    }
                    if (changedDevs.length > 0) {
                        sendData({"timeStamp": Math.round(new Date().getTime()/1000), "updates": changedDevs});
                    }
                    console.log("set new interval for sending");
                    window.setTimeout(senden, 100);
                };

                // vielleicht baut man lieber was mit setTimeout und setzt das jeweils neu wenn man daten ändert
                // das könnte den Browser entlasten, sofern den das 200ms Aufrufen überhaupt stört :D
                senden();

                $("#slider1").slider({ min: 0, max: 100, slide: function(event, ui) {
                    volumes.room1 = ui.value;
                    dataChanged = true;
                } });

                $("#slider2").slider({ min: 0, max: 100, slide: function(event, ui) {
                    volumes.room2 = ui.value;
                    dataChanged = true;
                } });

                $("#slider3").slider({ min: 0, max: 100, slide: function(event, ui) {
                    volumes.room3 = ui.value;
                    dataChanged = true;
                } });

                $("#slider4").slider({ min: 0, max: 100, slide: function(event, ui) {
                    volumes.room4 = ui.value;
                    dataChanged = true;
                } });
                $("#tabs").tabs();
                $("#v-tabs").tabs().addClass('ui-tabs-vertical');
                $(".lampel .circle").click(function() {
                    if($(this).hasClass('black')){
                        $(this).removeClass('black');
                    } else {
                        $(this).addClass('black');
                    }
                });
                var colorpicker_raum1 = new jQuery.ColorPicker('#colorpicker-raum1', {
                    imagepath: '/resources/images/colorpicker/',
                    change: function(hexcolor) {
                        red = hexcolor.substr(1,2);
                        green = hexcolor.substr(3,2);
                        blue = hexcolor.substr(5,2);
                        $('#par56select option:selected').each(function() {
                            devices[$(this).attr('name')].red = parseInt(red, 16);
                            devices[$(this).attr('name')].green = parseInt(green, 16);
                            devices[$(this).attr('name')].blue = parseInt(blue, 16);
                            devices[$(this).attr('name')].dirty = true;
                        });
                        console.log("data changed");

                    }
                });
                $.getJSON('/control/devices', function(data) {
                    devices = data;
                    for(var i=0;i<devices.length;i++) {
                        if(devices[i].type=="Par56Spot") {
                            $('#par56select').append("<option name=" + devices[i].deviceId + ">" + devices[i].deviceName + "</option>");
                        }
                    }

                });
                $('#par56select').change(function() {
                    $('#par56select option:selected').each(function() {
                        var red =  devices[$(this).attr('name')].red.toString(16);
			if(red.length == 1) {
				red += red;
			}
			var green = devices[$(this).attr('name')].green.toString(16);
			if(green.length == 1) {
				green += green;
			}
			var blue = devices[$(this).attr('name')].blue.toString(16);
			if(blue.length == 1) {

				blue += blue;
			}
			var hexstring = '#' + red + green + blue;
			console.log(hexstring);
                        colorpicker_raum1.hex(hexstring);
                    });
                });
            }
        );

    </script>
</head>
<body>
    <h1>CTDO Raumsteuerung</h1>

    <div id="tabs">
        <ul>
            <li><a href="#tabs-1">Global</a></li>
            <li><a href="#tabs-2">Raum 1</a></li>
            <li><a href="#tabs-3">Raum 2</a></li>
            <li><a href="#tabs-4">Raum 3</a></li>
            <li><a href="#tabs-5">Raum 4</a></li>
        </ul>
        <div id="tabs-1">

            <div class="buzzer">
                <span class="circle red">Zu</span>
                <button>Buzzern</button>
            </div>
            <div class="buzzer">
                <span class="circle green">Auf</span>
                <button>Buzzern</button>
            </div>
        </div>
        <div id="tabs-2">
            <div id="v-tabs" class="inner-tabs-container">
                <ul>
                    <li><a href="#v-tabs-1">Licht</a></li>
                    <li><a href="#v-tabs-2">Musik</a></li>
                    <li><a href="#v-tabs-3">Lampel</a></li>
                </ul>
                <div id="v-tabs-1">
                   <div id="colorpicker-raum1"></div>
                   <select multiple="multiple" id="par56select">

                   </select>
                </div>
                <div id="v-tabs-2">
                    <label for="slider1">Lautstärke Raum 1:</label><div id="slider1" class="slider"></div>
                </div>
                <div id="v-tabs-3">
                    <div class="lampel">
                        <span class="circle red" title="click to toggle"></span>
                        <span class="circle yellow" title="click to toggle"></span>
                        <span class="circle green" title="click to toggle"></span>

                    </div>

                </div>
            </div>

            <div class="switch">
                Raumlicht:<br />
                <input type="radio" name="raum-1-licht">An <input type="radio" name="raum-1-licht" checked="checked">Aus
            </div>

        </div>
        <div id="tabs-3">

            <label for="slider2">Lautstärke Raum 2:</label><div id="slider2" class="slider"></div>
        </div>

        <div id="tabs-4">
        
            <label for="slider3">Lautstärke Raum 3:</label><div id="slider3" class="slider"></div>

        </div>

        <div id="tabs-5">

            <label for="slider4">Lautstärke Raum 4:</label><div id="slider4" class="slider"></div>
           	
        </div>
    </div>


    <input type="button" value="Get Device 1" id="buttonLampe1" />

    <div id="messages"></div>


</body>
</html>
